<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_permissao_pagina.php");
require_once($config->diretorio_raiz()."/src/model/bd/Bi_grupo_permissaoDAO.php");
require_once($config->diretorio_raiz()."/src/model/bd/Bi_paginaDAO.php");
class Bi_permissao_paginaDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_permissao_pagina)
	{
		$inputs = array();
		if($bi_permissao_pagina->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_permissao_pagina->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_permissao_pagina->getGrupo() != "")
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>$bi_permissao_pagina->getGrupo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>null));
		}
		if($bi_permissao_pagina->getPagina() != "")
		{
			array_push($inputs, array('campo'=>':pagina', 'valor'=>$bi_permissao_pagina->getPagina()));
		}
		else
		{
			array_push($inputs, array('campo'=>':pagina', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_permissao_pagina (codigo, grupo, pagina) VALUES (:codigo, :grupo, :pagina)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_permissao_pagina($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_permissao_pagina where codigo = :codigo "; 
		$bi_permissao_pagina = new Bi_permissao_pagina();
		$rows_bi_permissao_pagina = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_permissao_pagina as $row)
		{
			$bi_permissao_pagina->setCodigo($row['codigo']);
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_permissao_pagina->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_permissao_pagina->setGrupo(new Bi_grupo_permissao());
			}
			if($row['pagina'] != "")
			{
				$paginaDAO = new Bi_paginaDAO();
				$bi_permissao_pagina->setPagina($paginaDAO->buscarBi_pagina($row['pagina']));
			}
			else
			{
				$bi_permissao_pagina->setPagina(new Bi_pagina());
			}
		}
		return $bi_permissao_pagina;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_permissao_pagina  ".$where;
		$lista_bi_permissao_pagina = array();
		$rows_bi_permissao_pagina = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_permissao_pagina as $row)
		{
			$bi_permissao_pagina = new Bi_permissao_pagina();
			$bi_permissao_pagina->setCodigo($row['codigo']);
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_permissao_pagina->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_permissao_pagina->setGrupo(new Bi_grupo_permissao());
			}
			if($row['pagina'] != "")
			{
				$paginaDAO = new Bi_paginaDAO();
				$bi_permissao_pagina->setPagina($paginaDAO->buscarBi_pagina($row['pagina']));
			}
			else
			{
				$bi_permissao_pagina->setPagina(new Bi_pagina());
			}
			array_push($lista_bi_permissao_pagina, $bi_permissao_pagina);
		}
		return $lista_bi_permissao_pagina;
	}
	public function atualizar($bi_permissao_pagina)
	{
		$inputs = array();
		if($bi_permissao_pagina->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_permissao_pagina->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_permissao_pagina->getGrupo() != "")
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>$bi_permissao_pagina->getGrupo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>null));
		}
		if($bi_permissao_pagina->getPagina() != "")
		{
			array_push($inputs, array('campo'=>':pagina', 'valor'=>$bi_permissao_pagina->getPagina()));
		}
		else
		{
			array_push($inputs, array('campo'=>':pagina', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_permissao_pagina  SET codigo = :codigo, grupo = :grupo, pagina = :pagina WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_permissao_pagina)
	{
		try
		{
			$sql = "DELETE FROM bi_permissao_pagina  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_permissao_pagina->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_permissao_pagina";
		$listaBi_permissao_pagina = array();
		$rows_bi_permissao_pagina = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_permissao_pagina as $row)
		{
			$bi_permissao_pagina = new Bi_permissao_pagina();
			$bi_permissao_pagina->setCodigo($row['codigo']);
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_permissao_pagina->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_permissao_pagina->setGrupo(new Bi_grupo_permissao());
			}
			if($row['pagina'] != "")
			{
				$paginaDAO = new Bi_paginaDAO();
				$bi_permissao_pagina->setPagina($paginaDAO->buscarBi_pagina($row['pagina']));
			}
			else
			{
				$bi_permissao_pagina->setPagina(new Bi_pagina());
			}
			array_push($listaBi_permissao_pagina,$bi_permissao_pagina );
		}
		return $listaBi_permissao_pagina;
	}
	public function buscarBi_permissao_paginaPorGrupo($grupo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_permissao_pagina where grupo = ".$grupo."";
		$lista_bi_permissao_pagina = array();
		$rows_bi_permissao_pagina = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_permissao_pagina as $row)
		{
			$bi_permissao_pagina = new Bi_permissao_pagina();
			$bi_permissao_pagina->setCodigo($row['codigo']);
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_permissao_pagina->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_permissao_pagina->setGrupo(new Bi_grupo_permissao());
			}
			if($row['pagina'] != "")
			{
				$paginaDAO = new Bi_paginaDAO();
				$bi_permissao_pagina->setPagina($paginaDAO->buscarBi_pagina($row['pagina']));
			}
			else
			{
				$bi_permissao_pagina->setPagina(new Bi_pagina());
			}
			array_push($lista_bi_permissao_pagina, $bi_permissao_pagina);
		}
		return $lista_bi_permissao_pagina;
	}
	public function buscarBi_permissao_paginaPorPagina($pagina)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_permissao_pagina where pagina = ".$pagina."";
		$lista_bi_permissao_pagina = array();
		$rows_bi_permissao_pagina = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_permissao_pagina as $row)
		{
			$bi_permissao_pagina = new Bi_permissao_pagina();
			$bi_permissao_pagina->setCodigo($row['codigo']);
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_permissao_pagina->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_permissao_pagina->setGrupo(new Bi_grupo_permissao());
			}
			if($row['pagina'] != "")
			{
				$paginaDAO = new Bi_paginaDAO();
				$bi_permissao_pagina->setPagina($paginaDAO->buscarBi_pagina($row['pagina']));
			}
			else
			{
				$bi_permissao_pagina->setPagina(new Bi_pagina());
			}
			array_push($lista_bi_permissao_pagina, $bi_permissao_pagina);
		}
		return $lista_bi_permissao_pagina;
	}
}